org.apache.ivy.core.module.descriptor

## Class Configuration

- java.lang.Object
- - org.apache.ivy.util.extendable.UnmodifiableExtendableItem
  - - org.apache.ivy.util.extendable.DefaultExtendableItem
    - - org.apache.ivy.core.module.descriptor.Configuration

All Implemented Interfaces:
  InheritableItem, ExtendableItem

Direct Known Subclasses:
  ConfigurationGroup, ConfigurationIntersection

    public class Configuration
    extends DefaultExtendableItem
    implements InheritableItem

Represents a module configuration

### Nested Class Summary

Nested Classes
`static class` `Configuration.Visibility`

### Constructor Summary

Constructors
Constructor and Description
`Configuration(Configuration source, ModuleRevisionId sourceModule)`
`Configuration(java.lang.String name)` Creates a new configuration.
`Configuration(java.lang.String name, Configuration.Visibility visibility, java.lang.String description, java.lang.String[] ext, boolean transitive, java.lang.String deprecated)` Creates a new configuration.

### Method Summary

Methods
`boolean` `equals(java.lang.Object obj)`
`static java.util.Collection` `findConfigurationExtending(java.lang.String conf, Configuration[] confs)`
`java.lang.String` `getDeprecated()` Returns the deprecation message, or `null` if not specified.
`java.lang.String` `getDescription()`
`java.lang.String[]` `getExtends()`
`java.lang.String` `getName()`
`ModuleRevisionId` `getSourceModule()`
`Configuration.Visibility` `getVisibility()`
`int` `hashCode()`
`boolean` `isTransitive()`
`void` `replaceWildcards(ModuleDescriptor md)`
`java.lang.String` `toString()`

### Methods inherited from class org.apache.ivy.util.extendable.DefaultExtendableItem

`setExtraAttribute`

### Methods inherited from class org.apache.ivy.util.extendable.UnmodifiableExtendableItem

`getAttribute, getAttributes, getExtraAttribute, getExtraAttributes, getQualifiedExtraAttributes, setStandardAttribute`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Configuration

    public Configuration(java.lang.String name)

Creates a new configuration.

Parameters:
  `name` - the name of the configuration

#### Configuration

    public Configuration(Configuration source,
                 ModuleRevisionId sourceModule)

#### Configuration

    public Configuration(java.lang.String name,
                 Configuration.Visibility visibility,
                 java.lang.String description,
                 java.lang.String[] ext,
                 boolean transitive,
                 java.lang.String deprecated)

Creates a new configuration.

Parameters:
  `name` - the name of the configuration
  `visibility` - the visibility of the configuration
  `description` - a description
  `ext` - the configurations to extend from
  `transitive` - indicates if the configuration is transitive
  `deprecated` - the deprecation message

### Method Detail

#### findConfigurationExtending

    public static java.util.Collection findConfigurationExtending(java.lang.String conf,
                                                  Configuration[] confs)

#### getDeprecated

    public java.lang.String getDeprecated()

Returns the deprecation message, or `null` if not specified.

Returns:
  Returns the deprecation message.

#### getDescription

    public java.lang.String getDescription()

Returns:
  Returns the description. It may be null.

#### getExtends

    public java.lang.String[] getExtends()

Returns:
  Returns the extends. May be empty, but never null.

#### getName

    public java.lang.String getName()

Returns:
  Returns the name. Never null;

#### getVisibility

    public Configuration.Visibility getVisibility()

Returns:
  Returns the visibility. Never null.

#### isTransitive

    public final boolean isTransitive()

Returns:
  Returns the transitive.

#### getSourceModule

    public ModuleRevisionId getSourceModule()

Specified by:
  `getSourceModule` in interface `InheritableItem`
Returns:
  the module in which this item was actually defined, if different from the module in which the item appears. May be null.

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### equals

    public boolean equals(java.lang.Object obj)

Overrides:
  `equals` in class `java.lang.Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `java.lang.Object`

#### replaceWildcards

    public void replaceWildcards(ModuleDescriptor md)